/*
 * XaAES - XaAES Ain't the AES
 *
 * A multitasking AES replacement for MiNT
 *
 */

#include "xa_types.h"
#include "xa_globl.h"
#include "objects.h"
#include "desktop.h"

/*
 *	Desktop Handling Routines
 */

OBJECT *desktop = NULL;

/*
 * Redraw the desktop object tree
 * - Blindingly simple or what?
 */
WindowDisplay redraw_desktop		/* HR */
{
	if (!desktop)
		return FALSE;

/* We can ignore the wind parameter here, as the desktop window never actually moves
   or changes dimensions */
	draw_object_tree(desktop, 0, 100);

	return TRUE;
}

/*
 * Set a new object tree for the desktop
 */
void set_desktop(OBJECT *new_desktop)
{
	if (new_desktop)
	{
/* Size & position the desktop to fit the root window */
		new_desktop->r.x = root_window->r.x;
		new_desktop->r.y = root_window->wa.y;
		new_desktop->r.w = root_window->r.w;
		new_desktop->r.h = root_window->r.h-root_window->wa.y;
	}

/* Set the desktop */
	desktop = new_desktop;

/* Now use the root window's auto-redraw function to redraw it */
	root_window->redraw = &redraw_desktop;
}
