/*
 * XaAES - XaAES Ain't the AES
 *
 * A multitasking AES replacement for MiNT
 *
 */

#include <mintbind.h>
#include <osbind.h>
#include <signal.h>

#include "xa_types.h"
#include "xa_globl.h"

#include "c_window.h"
#include "xa_codes.h"
#include "signals.h"

/*
 *	SIGNAL HANDLERS
 */

#define WIFSTOPPED(x)	(((int)((x) & 0xff) == 0x7f) && ((int)(((x) >> 8) & 0xff) != 0))
#define WSTOPSIG(x)		((int)(((x) >> 8) & 0xff))

extern AESPB dead_client_pb;
extern short dead_exit_contrl[];

/*
 * Spot dead children
 */
void __saveds HandleSIGCHLD(long signo)
{
	long r;
	short pid,x;
	XA_CLIENT *client,*parent;
	
	while((r = Pwaitpid(-1, 1, nil)) > 0)	/* ENOENT (See MiNT sources) */
	{
		pid = r >> 16;
		x = r;

		client = Pid2Client(pid);

		DIAGS(("Pwaitpid for '%s'(%d), code %d(0x%04x)\n",client ? client->proc_name : "?", pid,x,x));

		if (!client)		/* Not a AES client,  */
			continue;

		if (client->init)		/* HR: Now this is explicitely cleared in XA_client_exit itself (not!! in appl_exit!!) */
		{
			/* The client didnt call appl_exit. Tragically died in a accident. */
			DIAGS(("Closing %s(%d), pipe_rd: %d\n", client->proc_name, pid, client->client_end));
		/*	dead_client_pb.contrl = dead_exit_contrl;	  If client is dead, send ourselves a message to clean up... */

		/* - Gone back to calling directly, as the global command pipe has gone away */
			XA_client_exit(NOLOCKS, client, &dead_client_pb);	/* Run the application exit cleanup */
		}

		if (client->parent != AESpid)				/* Send a CH_EXIT message if the client */
		{											/* is not an AES child of the XaAES system */
			unsigned long retv = XA_OK;

			parent = Pid2Client(client->parent);
			
			if (parent && parent->client_end)  	/* HR: is the parent a active AES client? */
			{
				if (parent->waiting_for & XAWAIT_CHILD)		/* Wake up the parent if it's waiting */
					Fwrite(parent->kernel_end, (long)sizeof(unsigned long), &retv);
				
				DIAGS(("sending CH_EXIT to %d for %s(%d)\n", client->parent, client->proc_name, client->pid));

				send_app_message(NOLOCKS, nil, client->parent, CH_EXIT, AESpid, pid, x, 0, 0, 0);
			}
		}

		if (client->kernel_end)
		{
			Fclose(client->kernel_end);
			client_handle_mask &= ~(1L << client->kernel_end);
			DIAGS(("SIGCHILD: Closed kernel_end %d\n", client->kernel_end));
		}
		DIAGS(("SIGCHILD: Free client: %s(%d)\n",client->proc_name,pid));
		FreeClient(NOLOCKS, client);		/* HR: postponed */
	}
}

/*
 *	Catch CTRL+C and exit gracefully from the kernal loop
 */
void __saveds HandleSIGINT(long signo)
{
	shutdown = TRUE;
}
