/*
 * XaAES - XaAES Ain't the AES
 *
 * A multitasking AES replacement for MiNT
 *
 */

#include <osbind.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#include "xa_types.h"
#include "xa_globl.h"

#include "xa_form.h"
#include "objects.h"
#include "c_window.h"
#include RSCHNAME
#include "widgets.h"
#include "xa_graf.h"
#include "xa_rsrc.h"
#include "scrlobjc.h"

#if 0
#define CLIP(tree,obj,r)				\
	object_abs_coords(tree, obj, &r.x, &r.y);	\
	r.w = tree[obj].r.w;					\
	r.h = tree[obj].r.h;				\
	set_clip(r);
#endif

#define CLIP(tree,obj,r)	clear_clip()
#define set_clip(x)		/* We don't want this now! */

#if 0
#undef CLIP            /* Those set_clip(...) can't be useful */
#endif

/*
 *	FORM HANDLERS INTERFACE
 */

#if 0
extern XA_WINDOW *window_list;		/* The global system window stack */
#endif

void center_form(OBJECT *form, short barsizes)
{
	form->r.x =  root_window->wa.x
	           + (root_window->wa.w - form->r.w) / 2;
	form->r.y =  root_window->wa.y
	           + barsizes
	           + (root_window->wa.h - form->r.h) / 2;

}

/*
 *	Create a copy of an object tree
 *	- Intended for using the form templates in SYSTEM.RSC (we can't use them
 *	directly as this would cause problems when (for example) two apps do a form_alert()
 *	at the same time.
 */
static
OBJECT *CloneForm(OBJECT *form)
{
	short num_objs = 0, o;
	OBJECT *new_form;

	while ((form[num_objs++].ob_flags & LASTOB) == 0);		/* HR */

	new_form = malloc(sizeof(OBJECT) * num_objs);
	
	for (o = 0; o < num_objs; o++)
		new_form[o] = form[o];
	
	return new_form;
}

/*
 *	Free up a copy of a form template
 */
static
void DeleteClone(OBJECT *form)
{
	free(form);
}

/*
 * Small handler for clicks on an alert box
 */
WidgetBehaviour click_alert_widget	/* (XA_WINDOW *wind, XA_WIDGET *widg) */
{
	short sel_b = -1, f, b;
	unsigned long retv = XA_OK;
	RECT r;
	XA_WIDGET_TREE *wt = widg->stuff;
	OBJECT *alert_form;
	
	if (window_list != wind)			/* You can only work alerts when they are on top */
		return FALSE;

	alert_form = wt->tree;

	rp_2_ap(wind, widg, &r);	/* Convert relative coords and window location to absolute screen location */

	f = find_object(alert_form, 0, 10, r.x + widg->click_x, r.y + widg->click_y);

	if (   f >= ALERT_BUT1			/* Did we click on a valid button? */
		&& f <  ALERT_BUT1 + 3
		&& !(alert_form[f].ob_flags & HIDETREE)
		)
	{
		clear_clip();
	
		b = watch_object(alert_form, f, SELECTED, 0);

		if (b)
			sel_b = f + 1 - ALERT_BUT1;

		if (sel_b > -1)
		{
			if (wt->owner != AESpid)
			{
			/* HR static pid array */
				XA_CLIENT *client = Pid2Client(wt->owner);
				client->waiting_pb->intout[0] = f - ALERT_BUT1 +1;
				Fwrite(client->kernel_end, (long)sizeof(unsigned long), &retv);	/* Write success to clients reply pipe to unblock the process */
			}
		
			close_window(lock, wind);
			delete_window(lock, wind);
			DeleteClone(alert_form);	/* Delete this copy of the alert form */
		}
	}
	
	return FALSE;
}

/*
 *	Form_alert handler v2.1
 */

/* HR: Ok, I know nobody is perfect, but only a few are this stupid. 
			Corrupting a user's alert string. (see xalert.h)
   Partly rewritten using IPFF.
*/
#include "ipff.h"

#define MAX_X 100
#define MAX_B 20

static
short get_parts(short m, char to[][MAX_X+1], short *retv)
{
	short n = 0;
	while (n < m)
	{
		short s = lstr(to[n++],'|]');		/* delimited string, no translation */
		if (s eq '|')
			sk1();
		elif (s eq ']')
		{
			skc();
			break;
		othw					/* must be end of string */
			*retv = 0;
			break;
		}
	}
	return n;
}

static
short max_w(short m, char to[][MAX_X+1], short *tot)
{
	short n = 0, x = 2, t = 0;
	while (n < m)
	{
		short l = strlen(to[n]);
		if (l > x)
			x = l;
		t += l+3;
		n++;
	}
	if (tot)
		*tot = t * display.c_max_w;
	return x*display.c_max_w;
}

/* HR: changed thus, that a alert is always displayed, whether format error or not.
       otherwise the app is suspended and the screen & keyb are locked,
       and you can do nothing but a reset. :-(
*/

short do_form_alert(LOCK lock, short default_button, char *alert, short owner)
{
	WindowKeypress key_alert_widget;
	XA_WINDOW *alert_window;
	XA_WIDGET_LOCATION dialog_toolbar_loc = {LT, 0, 0};	/* HR */
	short x, y, w, h, n_lines, n_buttons, icon = 0, m_butt_w,
	      retv = 1, b, f;
	char alert_text[5][MAX_X+1],	/* Texts to display in the alert */
		 button_text[3][MAX_X+1];	/* Text for buttons (note: use MAX_X to get coercible row type) */
	OBJECT *alert_form;
	OBJECT *alert_icons;

	DIAG((D.form,owner,"called do_form_alert(%s)\n",alert));

/* HR: < */

	for (f = 0; f < 5; f++)
		alert_text[f][0] = '\0';

	ipff_init(MAX_X,-1,0,nil,alert,nil);

	if (sk() eq '[')		/* skip white space and give non_white char */
	{
		skc();				/* skip char & following white space, give non_white char */
		icon = idec();		/* give decimal number */
		if (sk() eq ']')
			skc();
	}

	if (sk() ne '[')
		retv = 0;
	else
		sk1();

	n_lines = get_parts(5,alert_text,&retv);	/* parse ...|...|... ... ] */

	if (sk() ne '[')
		retv = 0;
	else
		sk1();

	ipff_init(MAX_B,-1,0,nil,nil,nil);

	n_buttons = get_parts(3,button_text,&retv);
	
	w = max_w(n_lines,    alert_text, nil);
	    max_w(n_buttons, button_text, &m_butt_w);

	if (m_butt_w > w)
		w = m_butt_w;

	w += 50;
/* >  */


/* Create a copy of the alert box template */
	alert_form = CloneForm(ResourceTree(system_resources, ALERT_BOX));
	alert_icons = ResourceTree(system_resources, ALERT_ICONS);

	alert_form->r.w = w;
	center_form(alert_form, ICON_H);

#if 0
	if MONO				/* Hmm... perhaps this should be done in */
	{					/* "color mode" too? <mk> */
		long obspec = (long)alert_form->ob_spec;
		obspec &= ~0xfL ;
		obspec |= (display.dial_colours.bg_col & 0xf);	/* Interior color */
		alert_form->ob_spec = (void *)obspec;
	}
#endif

	{	/* HR */
		short icons[7] = {ALR_IC_SYSTEM, ALR_IC_WARNING, ALR_IC_QUESTION, ALR_IC_STOP,
						  ALR_IC_INFO,   ALR_IC_DRIVE,   ALR_IC_BOMB};
		if (icon > 7 || icon < 0)
			icon = 0;
		
		for (f = 0; f < 7; f++)
		{
			ICONBLK *ai = (alert_icons + icons[f]    )->ob_spec,
			        *af = (alert_form  + ALERT_D_ICON)->ob_spec;
			ai->ic.x = af->ic.x;
			ai->ic.y = af->ic.y;
		}

		(ICONBLK *)(alert_form + ALERT_D_ICON)->ob_spec = (ICONBLK *)(alert_icons + icons[icon])->ob_spec;
	}

	for (f = 0; f < 5; f++)				/* Fill in texts */
		sprintf(((TEDINFO *)alert_form[ALERT_T1 + f].ob_spec)->te_ptext, "%s", alert_text[f]);
	
	x = w - m_butt_w; 					/* Space the buttons evenly */
	b = x / (n_buttons + 1);	
	x = b;

	for (f = 0; f < n_buttons; f++)		/* Fill in & show buttons */
	{
		short w = strlen(button_text[f])+3;
		w *= display.c_max_w;
		sprintf((char *)alert_form[ALERT_BUT1 + f].ob_spec, "%s", button_text[f]);
		alert_form[ALERT_BUT1 + f].r.w = w;
		alert_form[ALERT_BUT1 + f].r.x = x;
		alert_form[ALERT_BUT1 + f].ob_flags &= ~(HIDETREE|DEFAULT);
		alert_form[ALERT_BUT1 + f].ob_state = 0;
		x += w + b;
	}

	if (default_button > 0)				/* Set the default button if it was specified HR: check > 0 */
	{
		if (default_button > n_buttons)		/* HR: please check your input! */
			default_button = n_buttons;
		alert_form[ALERT_BUT1 + default_button - 1].ob_flags |= DEFAULT;
	}

	for (f = n_buttons; f < 3; f++)		/* Hide unused buttons */
		alert_form[ALERT_BUT1 + f].ob_flags |= HIDETREE;

/* Create a window and attach the alert object tree to it */
/* HR: better centered now */
	alert_window = create_window(lock, nil, owner, false,
						NAME|MOVE|STORE_BACK|NO_WORK, MG,
						display.r,nil,nil);

	dialog_toolbar_loc.r.x = alert_window->wa.x - alert_window->r.x;
	dialog_toolbar_loc.r.y = alert_window->wa.y - alert_window->r.y;
/*	if MONO		/* Due to the nature of push buttons */
		dialog_toolbar_loc.r.x++,dialog_toolbar_loc.r.y++;
*/	set_toolbar_widget(lock, alert_window, dialog_toolbar_loc, alert_form);
	
/* Change the click & drag behaviours for the alert box widget, because alerts return a number */
/* 1 to 3, not an object index. */
/* HR: we also need a keypress handler for the default button (if there) */
	alert_window->keypress = key_alert_widget;
	alert_window->widgets[XAW_TOOLBAR].behaviour[XACB_CLICK] = click_alert_widget;
	alert_window->widgets[XAW_TOOLBAR].behaviour[XACB_DRAG] = click_alert_widget;
	((XA_WIDGET_TREE *)alert_window->widgets[XAW_TOOLBAR].stuff)->owner = owner;
	
	alert_window->active_widgets |= NO_REDRAWS;	/* We don't want any redraw messages  */
											/* - The widget handler will take care of it */
/* Set the window title to be the client's name to avoid confusion */
	alert_window->widgets[XAW_TITLE].stuff = Pid2Client(owner)->name;	 /* HR */

/* HR: Completely transparent positioning of form in window (!center) */
	alert_window->r = wa_to_curr(alert_window,1,alert_form->r);
	calc_work_area(alert_window);
#if TWOLISTS
	open_window(lock, owner, alert_window->handle, alert_window->r);
#else
	alert_window->is_open = TRUE; 

	focus = pull_wind_to_top(lock, alert_window);			/* HR */
	after_top(lock, false);
	display_non_topped_window(lock, 50, alert_window, NULL);
#endif
	v_show_c(V_handle, 0);		/* For if the app has hidden the mouse */
	return retv;
}

/*
 * Primitive version of form_center....
 * - This ignores shadows & stuff
 *
 * HR: It seems that every app knows that :-)
 *
 */
AES_function XA_form_center	/* (LOCK lock, XA_CLIENT *client, AESPB *pb) */
{
	OBJECT *ob = pb->addrin[0];
	short *o = pb->intout;

	CONTROL(0,5,1)

/* DIAG((D.form,client->pid,"form_center ob=%lx,o=%lx\n", ob, o));
*/
	if (ob && o)
	{
		short x, y, w, h;

		w = ob->r.w;
		h = ob->r.h;
		
		x = (root_window->wa.w - w) / 2;		/* HR: desktop work area */
		y = (root_window->wa.h - h) / 2;
		
		ob->r.x = x;
		ob->r.y = y;
	
		*o++ = 1;
		*o++ = x;
		*o++ = y;
		*o++ = w;
		*o   = h;

/* DIAG((D.form,client->pid,"form_center %d/%d,%d/%d\n",x,y,w,h));
*/	}

	return XAC_DONE;
}

AES_function XA_form_button	/* (LOCK lock, XA_CLIENT *client, AESPB *pb) */
{
	OBJECT *tree = (OBJECT*)pb->addrin[0];
	short ob = pb->intin[0];
	short is, os;
	RECT r;

	CONTROL(2,2,1)

	pb->intout[1] = 0;

	if (tree[ob].ob_flags & EDITABLE)	/* Select a new editable text field? */
	{
	/*	
	 * Shouldn't this really do all that's done in form_do?
	 */

		pb->intout[1] = ob;
	}

	if (((tree[ob].ob_flags & HIDETREE) 		/* Was click on a valid selectable object? */
		|| (    tree[ob].ob_state & DISABLED))
		|| ( ! (tree[ob].ob_flags & (SELECTABLE | EXIT | TOUCHEXIT))))
	{
		pb->intout[0] = 1;
		return XAC_DONE;
	}

	CLIP(tree, ob, r);

	os = tree[ob].ob_state;
	is = os ^ SELECTED;

	if (tree[ob].ob_flags & TOUCHEXIT)	/* Change state & exit for TOUCHEXIT objects */
	{
/*
 * Surely radio buttons must be handled as well?
 */
		/* Only selectable objects change appearance! */
		if (tree[ob].ob_flags & SELECTABLE)
		{
			tree[ob].ob_state = is;
			v_hide_c(V_handle);
			draw_object_tree(tree, ob, MAX_DEPTH);
			v_show_c(V_handle, 1);
		}

		pb->intout[1] = ob;
		
		pb->intout[0] = 0;
		
		if (pb->intin[1] == 2)	/* Double click? */
		{
			pb->intout[1] |= 0x8000;
		}
		
		return XAC_DONE;
	}

/*
 * Should this perhaps be done in watch_object()?
 */
	tree[ob].ob_state = is;
	CLIP(tree, ob, r);
	v_hide_c(V_handle);
	draw_object_tree(tree, ob, MAX_DEPTH);
	v_show_c(V_handle, 1);
		
	if (watch_object(tree, ob, is, os))	/* Do a watch to see if object is really selected */
	{
		if ( ! (tree[ob].ob_flags & SELECTABLE))
		{
			tree[ob].ob_state = os;
			v_hide_c(V_handle);
			draw_object_tree(tree, ob, 2);
			v_show_c(V_handle, 1);
		}
/*
 * Surely this should check for radio buttons?
 */
 		if (tree[ob].ob_flags & EXIT)
		{
			pb->intout[1] = ob;
			pb->intout[0] = 0;
#ifdef CLIP
			clear_clip();
#endif
			
			return XAC_DONE;
		}
	}

#ifdef CLIP
	clear_clip();
#endif

	pb->intout[0] = 1;
	return XAC_DONE;
} 

short find_flag(OBJECT *ob, short flag)
{
	short f = 0;
	do
		if (ob[f].ob_flags & flag)
			return f;
	while ( ! (ob[f++].ob_flags & LASTOB));	/* HR: Check LASTOB before incrementing */
	return -1;
}

short find_cancel_button(OBJECT *ob)
{
	extern char cancel_buttons[][CB_L];

	short f = 0;
	do
	{
		if (   (ob[f].ob_type & 0xff) == G_BUTTON
			&& (ob[f].ob_flags & (SELECTABLE|TOUCHEXIT|EXIT)) != 0  )
		{
			short l;
			char t[32]; char *s = t,*e;
			e = (char *)ob_spec(ob+f);
			l = strlen(e);
			if (l < 32)
			{
				strcpy(t,e);
				/* strip surrounding spaces */
				e = t + l;
				while (*s == ' ') s++;
				while (*--e == ' ')  ;
				*++e = 0;
				if (e-s < CB_L)	/* No use comparing longer strings */
				{
					short i = 0;
					while (cancel_buttons[i][0])
						if (stricmp(s,cancel_buttons[i]) == 0)
							return f;
						else i++;
				}
			}
		}
	}
	while ( ! (ob[f++].ob_flags & LASTOB));
	return -1;
}

/* HR (*)() */
AES_function XA_form_keybd	/* (LOCK lock, XA_CLIENT *client, AESPB *pb) */
{
	short form_cur(OBJECT *form, short keycode, short obj);
	OBJECT *form = pb->addrin[0];
	short obj = pb->intin[0];
	short keycode = pb->intin[1];
	RECT r;
	short o, last_ob, cur_key;
	
	CONTROL(3,3,1)

DIAG((D.keybd,client->pid,"form_keybd():%x,%x,%x\n", pb->intin[0], pb->intin[1], pb->intin[2]));
	
	pb->intout[0] = 1;				/* continue */
	pb->intout[1] = obj;			/* pnxt_obj */
	pb->intout[2] = 0;				/* pchar */

/* HR: removed spurious, and wrong check on EDITABLE which caused exit,
       and assign to a TEDINFO, which after all was not used.
*/
	o = form_cur(form, keycode, obj);	/* HR: More duplicate code removed */

	cur_key = o >= 0;

	if (!cur_key)
	{		
		/* Return - select default (if any) */
		/* HR: Enter */
DIAG((D.keybd,client->pid,"enturn XA_kbd\n"));

		if ((keycode == 0x1c0d || keycode == 0x720d))
			o = find_flag(form, DEFAULT);
		else if (keycode == 0x6100)		/* UNDO */
			o = find_cancel_button(form);

		if (o >= 0)
		{
			pb->intout[0] = 0;
			pb->intout[1] = o;		/* nxt_obj */
DIAG((D.keybd,client->pid,"enturn XA_kbd done\n"));
			return XAC_DONE;
		}
		else			
		{		/* just a plain key - insert character */
DIAG((D.keybd,client->pid,"passing character back to client\n"));
			pb->intout[2] = keycode;
		}
	}
	else	/* Moved from four places above. */
	{
		if (o != obj)	/* If edit field has changed, update the display */
		{	
			form[o].ob_state |= IS_EDIT;
			form[obj].ob_state &= ~IS_EDIT;
			
			CLIP(form, obj, r);
			v_hide_c(V_handle);
			draw_object_tree(form, obj, 2);
#if WRONG_LEN
			((TEDINFO *)ob_spec(&form[o]))->te_tmplen = strlen(((TEDINFO*)ob_spec(&form[o]))->te_ptext);
#endif
			CLIP(form, o, r);
			draw_object_tree(form, o, 2);
			v_show_c(V_handle, 1);

			pb->intout[1] = o;
		}
	}
	
	return XAC_DONE;
}

AES_function XA_form_alert	/* (LOCK lock, XA_CLIENT *client, AESPB *pb) */
{
	CONTROL(1,1,1)

	client->waiting_pb = pb;
	
DIAG((D.form,client->pid,"XA_alert %s\n",(char *)pb->addrin[0]));
	do_form_alert(lock, pb->intin[0], (char *)pb->addrin[0], client->pid);

	return XAC_BLOCK;
}

char error_alert[100];

AES_function XA_form_error	/* (LOCK lock, LOCK lock, XA_CLIENT *client, AESPB *pb) */
{
	char *msg;
	char icon;

	CONTROL(1,1,0)

	client->waiting_pb = pb;
	
	switch(pb->intin[0])
	{
	case 2:
		msg = "File not found.";
		icon = '5';
		break;
	case 3:
		msg = "Path not found.";
		icon = '5';
		break;
	case 4:
		msg = "No more file handles.";
		icon = '5';
		break;
	case 5:
		msg = "Access denied.";
		icon = '5';
		break;
	case 8:
		msg = "Insufficient memory.";
		icon = '6';
		break;
	case 10:
		msg = "Invalid enviroment.";
		icon = '6';
		break;
	case 11:
		msg = "Invalid format.";
		icon = '6';
		break;
	case 15:
		msg = "Invalid drive specification.";
		icon = '5';
		break;
	case 16:
		msg = "Attempt to delete working directory.";
		icon = '5';
		break;
	case 18:
		msg = "No more files.";
		icon = '5';
		break;
	default:
		msg = "Unknown error.";
		icon = '7';
		break;
		
	}
	
	sprintf(error_alert, "[%c][ ERROR: | %s ][ Bugger ]", icon, msg);

DIAG((D.form,client->pid,"alert_err %s",error_alert));
	do_form_alert(lock, 1, error_alert, client->pid);

	return XAC_BLOCK;
}

short has_default(OBJECT *ob)
{
	short f = 0;
	do
		if (ob[f].ob_flags & DEFAULT)
			return TRUE;
	while ( ! (ob[f++].ob_flags & LASTOB));
	return FALSE;
}

/*
 *  Begin/end form handler
 *  This is important - I hope most programs call this, as XaAES puts its dialogs
 *  in windows, and the windows are created here...
 */
AES_function XA_form_dial	/* (LOCK lock, XA_CLIENT *client, AESPB *pb) */
{	
	XA_WINDOW *dialog_window;
	RECT r;

	CONTROL(9,1,0)

	switch(pb->intin[0])
	{
	case FMD_START: 
		/* Work out sizing */
		calc_window(client->pid, WC_BORDER, NAME, (RECT *)&pb->intin[5], &r);

/* And create the window. It stays fixed until form_do is called
   when it gets a MOVE property.
   We create a window owned by the client so it will get button clicks for this area
   (in case it's gonna handle things its own way)
*/
		client->zen = dialog_window = create_window(lock, nil, client->pid, false,
#if PRESERVE_DIALOG_BGD
		STORE_BACK | NO_MESSAGES |
#endif
		NAME | NO_WORK, MG,
		r, nil, nil);

		dialog_window->created_by_FMD_START = TRUE;
/* Set the window title to be the clients name to avoid confusion */
		dialog_window->widgets[XAW_TITLE].stuff = client->name;		/* HR added NAME to the create's */
#if TWOLISTS
		open_window(lock, client->pid, dialog_window->handle, dialog_window->r);
#else
		dialog_window->is_open = TRUE;
		focus = pull_wind_to_top(lock, dialog_window);			/* HR */
		after_top(lock, false);
		display_non_topped_window(lock, 51, dialog_window, NULL);
#endif		
		break;
	case FMD_GROW:
		break;
	case FMD_SHRINK:
		break;
	case FMD_FINISH:
		dialog_window = client->zen;
		if (dialog_window)	/* If the client's dialog window is still hanging around, dispose of it... */
		{
			clear_clip();
			client->zen = NULL;
			close_window(lock, dialog_window);
			delete_window(lock, dialog_window);
		} else	/* This was just a redraw request */
			display_windows_below(lock, (RECT *)&pb->intin[5], window_list);		/* HR */

		break;
	}
	
	pb->intout[0] = 1;
	
	return XAC_DONE;
}

/*
 *	Form_do() click handler
 */

short exit_form(LOCK lock, XA_WINDOW *wind, XA_WIDGET *widg, short f, short os)
{
	XA_WIDGET_TREE *wt = widg->stuff;
	/* HR static pid array */
	XA_CLIENT *client = Pid2Client(wt->owner);
	OBJECT *form = wt->tree;
	unsigned long retv = XA_OK;

	if (wt->handler)
	{
		ODC_PARM parm;
		parm.tree = form;
		parm.object = f;
		(*(wt->handler))(lock, &parm);
		if (os >= 0)
		{
			form[f].ob_state = os;
			draw_object_tree(form, f, MAX_DEPTH);
		}
		return TRUE;
	}

	client->waiting_pb->intout[0] = f;
	Fwrite(client->kernel_end, (long)sizeof(unsigned long), &retv);	/* Write success to clients reply pipe to unblock the process */
	if ( ! (wind->created_by_FMD_START))	/* If FMD_START didn't create this window, destroy it now */
	{									/* - if it did, then we expect the app to call FMD_FINISH to delete the window */
#if 0
		XA_WINDOW *wl = wind->next;
#endif
		client->zen = NULL;
		close_window(lock, wind);
		delete_window(lock, wind);
#if 0		/* Dont doe this: for this kind of dialogue's the drawing is completely out of control of the AES */
			/* Moreover, many form_do's can be performed (and are) on a single dialogue, each form_do
			   terminated by any kind of (TOUCH_)EXIT object */
		display_windows_below(lock, &wind->r, wl);		/* HR */
#endif
	}

	return FALSE;
}

WindowKeypress handle_form_key /* LOCK lock, XA_WINDOW *wind, unsigned short keycode */ /* HR */
{
	XA_WIDGET *widg = wind->widgets + XAW_TOOLBAR;
	XA_WIDGET_TREE *wt = widg->stuff;
	OBJECT *form;
	TEDINFO *ed_txt;
	RECT r;
	short o, ed_obj, last_ob;
	short update = 0, cur_key;

	DIAG((D.form,wind->owner,"handle_form_key()\n"));

	form = wt->tree;
	ed_obj = wt->edit_obj;

DIAG((D.k,wind->owner,"got keypress in form\n"));

	o = form_cur(form, keycode, ed_obj);	/* HR: More duplicate code removed */

	cur_key = o >= 0;

	if (!cur_key)
	{
		/* Return - select default (if any) */
		/* HR: Enter */

		if (keycode == 0x1c0d || keycode == 0x720d)
			o = find_flag(form, DEFAULT);
		else if (keycode == 0x6100)		/* UNDO */
			o = find_cancel_button(form);

		if (o >= 0)
			exit_form(lock, wind, widg, o, -1);
		else	/* handle plain key */
		{
			/* HR: another massive code duplication,
					they should be the same,
					but they were NOT! :-( */

			/* HR: moved to here, where it is needed, and then check if the field IS editable */
			if (form[ed_obj].ob_flags&EDITABLE)
			{
				ed_txt = (TEDINFO*)ob_spec(&form[ed_obj]);
#if WRONG_LEN
				update = ed_char(ed_txt, keycode);
				wt->edit_pos = ed_txt->te_tmplen;
#else
				update = ed_char(wt, ed_txt, keycode);	/* HR pass the widget tree */
#endif
			}
		}
	}

	if (update)	/* Moved from a number of places above. */
	{
		CLIP(form, ed_obj, r);
		v_hide_c(V_handle);
		draw_object_tree(form, ed_obj, MAX_DEPTH);
		v_show_c(V_handle, 1);
	}

	if (cur_key)	/* Moved from four places above. */
	{
		if (o != ed_obj)	/* If edit field has changed, update the display */
		{
			form[o].ob_state |= IS_EDIT;
			form[ed_obj].ob_state &= ~IS_EDIT;
			
			CLIP(form, ed_obj, r);
			v_hide_c(V_handle);
			draw_object_tree(form, ed_obj, MAX_DEPTH);
#if WRONG_LEN
			if (form[o].ob_flags&EDITABLE)		/* HR: Just to be sure */
			{
				wt->edit_obj = o;
				wt->edit_pos = ((TEDINFO *)ob_spec(&form[o]))->te_tmplen = strlen(((TEDINFO *)ob_spec(&form[o]))->te_ptext);
			}
#endif
			CLIP(form, o, r);
			draw_object_tree(form, o, MAX_DEPTH);
			v_show_c(V_handle, 1);
		}
	}

	return TRUE;
}

/*
 *	Non-blocking form_do
 *	- Uses an object tree widget in a window to implement the form handler.
 */
AES_function XA_form_do	/* (LOCK lock, XA_CLIENT *client, AESPB *pb) */
{
	XA_WINDOW *dialog_window;
	XA_WIDGET_TREE *wt;
	OBJECT *form = (OBJECT *)pb->addrin[0];
	XA_WIDGET_LOCATION dialog_toolbar_loc = {LT, 0, ICON_H};	/* HR */
	RECT r;
	short startedit = -1;
	
	CONTROL(1,1,1)

	DIAG((D.form,client->pid,"form_do()\n"));

	client->waiting_pb = pb;
	
	if (!client->zen)	/* If the client hasn't called FMD_START (naughty), create a window for the dialog */
	{
		/* Work out sizing */
		calc_window(client->pid, WC_BORDER, 0, &form->r, &r);

		/* Create the window */
		client->zen = dialog_window = create_window(lock, nil, client->pid, false,
		NO_WORK | NO_MESSAGES
#if PRESERVE_DIALOG_BGD
		| STORE_BACK
#endif
		, MG, r, nil, nil);

		dialog_window->created_by_FMD_START = FALSE;
	/* Set the window title to be the clients name to avoid confusion */
		dialog_window->widgets[XAW_TITLE].stuff = client->name;
	} else
	{
		dialog_window = client->zen;
		dialog_window->owner = client->pid;
		
	}
	
	client->waiting_for = XAWAIT_DIALOG;	/* |XAWAIT_KEY */
	dialog_toolbar_loc.r.y = dialog_window->wa.y - dialog_window->r.y;		/* HR */
	set_toolbar_widget(lock, dialog_window, dialog_toolbar_loc, form);
	
	/*
	 * If there is an editable field, we'll need a keypress handler.
	 *  HR: We need a keypress handler for the default object as well
	 */
	if (has_default(form))
		dialog_window->keypress = handle_form_key;
	startedit = pb->intin[0];
	if (startedit <= 0)
		startedit = find_flag(form, EDITABLE);		/* HR */
	wt = (XA_WIDGET_TREE *)dialog_window->widgets[XAW_TOOLBAR].stuff;
	wt->owner = client->pid;
	wt->edit_obj = startedit;
	wt->edit_pos = 0;	/* Needed? */
	
	if (startedit >= 0)	/* Set up keypress handler if needed */
	{
		TEDINFO *te = (TEDINFO *)ob_spec(&form[startedit]);
		short f = 0;

		do		/* Ensure that there aren't two fields flagged as the current edit field */
			form[f].ob_state &= ~IS_EDIT;
		while( ! (form[f++].ob_flags & LASTOB));	/* HR: Check LASTOB before incrementing */
		
		dialog_window->keypress = handle_form_key;
		form[startedit].ob_state |= IS_EDIT;
#if WRONG_LEN
		te->te_tmplen = strlen(te->te_ptext);
		wt->edit_pos = te->te_tmplen;
#else
		wt->edit_pos = strlen(te->te_ptext);
#endif
		CLIP(form, startedit, r);
		v_hide_c(V_handle);
		draw_object_tree(form, startedit, 2);
		v_show_c(V_handle, 1);
	}

	dialog_window->active_widgets |= NO_MESSAGES;	/* We don't want any redraw messages  */
											/* - the widget handler will take care of it */
	dialog_window->is_open = TRUE;
#if TWOLISTS
	wi_remove(&closed_windows, dialog_window);
	wi_put_first(&open_windows, dialog_window);
#else
/* HR: The windows must be brought to top, to get the focus correct */
	focus = pull_wind_to_top(lock, dialog_window);			/* HR */
#endif
#if 0		/* HR: Yeah, when form_do is called, the dialogue ia already drawn by the app. */
	display_window(lock, dialog_window);
#endif

	return XAC_BLOCK;
}

/*
 * HR:
 * Small handler for ENTER/RETURN/UNDO on an alert box
 */
WindowKeypress key_alert_widget /* LOCK lock, XA_WINDOW *wind, unsigned short keycode */ /* HR */
{
	XA_WIDGET *widg = (wind->widgets) + XAW_TOOLBAR;
	unsigned long retv = XA_OK;
	short f = 0;
	RECT r;
	XA_WIDGET_TREE *wt = widg->stuff;
	OBJECT *alert_form;
	
	if (window_list != wind)			/* You can only work alerts when they are on top */
		return FALSE;

	alert_form = wt->tree;

	rp_2_ap(wind, widg, &r);	/* Convert relative coords and window location to absolute screen location */

	if (keycode == 0x720d || keycode == 0x1c0d)
		f = find_flag(alert_form, DEFAULT);
	else if (keycode == 0x6100)   				/* UNDO */
		f = find_cancel_button(alert_form);

	if (   f >= ALERT_BUT1			/* Is f a valid button? */
		&& f <  ALERT_BUT1 + 3
		&& !(alert_form[f].ob_flags & HIDETREE)
		)
	{
		clear_clip();
		if (wt->owner != AESpid)
		{
		/* HR static pid array */
			XA_CLIENT *client = Pid2Client(wt->owner);
			client->waiting_pb->intout[0] = f - ALERT_BUT1 + 1;
			Fwrite(client->kernel_end, (long)sizeof(unsigned long), &retv);	/* Write success to clients reply pipe to unblock the process */
		}
	
		close_window(lock, wind);
		delete_window(lock, wind);
		DeleteClone(alert_form);	/* Delete this copy of the alert form */
	}

	return FALSE;
}

/*
 * Returns the object number of this object's parent or -1 if it is the root
 */
short GetParent(OBJECT *t, short object)
{
	short last;
	
	if (object == 0)
		return -1;
	else
	{
		do
		{
			last = object;
			object = t[object].ob_next;
		} while(t[object].ob_tail != last);
		return object;
	}
}

/*
 * Sets one of a group of radio buttons, and clears the rest.
 * Includes patch to allow for pop_icons as radio buttons.
 */
static
void Radio_b(OBJECT *d, short object)
{
	short parent, o;
	RECT r;

	if ((parent = GetParent(d, object)) == -1)
		return;		/* Only reasonable thing to do */

	o = d[parent].ob_head;
	
	while (o != parent)
	{
		if ((d[o].ob_flags & RBUTTON) && (d[o].ob_state & SELECTED))
		{
			d[o].ob_state &= ~SELECTED;

			CLIP(d, o, r);
			v_hide_c(V_handle);
			draw_object_tree(d, o, MAX_DEPTH);
			v_show_c(V_handle, 1);
		}
		
		o = d[o].ob_next;
	}
	
	d[object].ob_state |= SELECTED;

	CLIP(d, object, r);
	v_hide_c(V_handle);
	draw_object_tree(d, object, MAX_DEPTH);
	v_show_c(V_handle, 1);
}

WidgetBehaviour click_object_widget	/* (LOCK lock, XA_WINDOW *wind, XA_WIDGET *widg) */
{
	short f, is, os;
	XA_WIDGET_TREE *wt = widg->stuff;
	OBJECT *form;
	RECT r;

	if (window_list != wind)
	{
		focus = pull_wind_to_top(lock, wind);			/* HR */
		after_top(lock, false);
		display_non_topped_window(lock, 52, wind, nil);
		return FALSE;
	}

/* HR: for after moving: adjusts form's x & y */
	form = rp_2_ap(wind, widg, &r);	/* Convert relative coords and window location to absolute screen location */
	f = find_object(form, 0, 10, r.x + widg->click_x, r.y + widg->click_y);
DIAG((D.mouse,wind->owner,"click_object_widget %d,%d on %d\n",r.x + widg->click_x, r.y + widg->click_y, f));

	/* find_object can't report click on a HIDETREE object. */
	/* HR: Unfortunately it could. Fixed that. */
	if (   (    form[f].ob_state &  DISABLED)	/* Was click on a valid selectable object? */
		|| ( ! (form[f].ob_flags & (EDITABLE | SELECTABLE | EXIT | TOUCHEXIT))))
		return FALSE;

	if ((form[f].ob_type&0xff) == G_SLIST)
		click_scroll_list(lock, form, f, r.x + widg->click_x, r.y + widg->click_y);
	else
	{
		if ((form[f].ob_flags & EDITABLE) && (f != wt->edit_obj))
		{	/* Select a new editable text field? */
			TEDINFO *txt = (TEDINFO *)ob_spec(&form[f]);
		
			form[f].ob_state |= IS_EDIT;
			form[wt->edit_obj].ob_state &= ~IS_EDIT;

			CLIP(form, wt->edit_obj, r);
			v_hide_c(V_handle);
			draw_object_tree(form, wt->edit_obj, MAX_DEPTH);

			wt->edit_obj = f;
			wt->edit_pos =
#if WRONG_LEN
				txt->te_tmplen =
#endif
					strlen(txt->te_ptext);

			CLIP(form, f, r);
			draw_object_tree(form, f, MAX_DEPTH);
			v_show_c(V_handle, 1);
		}

		CLIP(form, f, r);

		os = form[f].ob_state;
		is = os ^ SELECTED;

	 	if (form[f].ob_flags & TOUCHEXIT)		/* Touch Exit button? */
	 	{
			if (form[f].ob_flags & RBUTTON)
			{	/* Was click on a radio button? */
				Radio_b(form, f);
			} else if (form[f].ob_flags & SELECTABLE)
			{
				form[f].ob_state = is;
				v_hide_c(V_handle);
				draw_object_tree(form, f, MAX_DEPTH);
				v_show_c(V_handle, 1);
			}

			exit_form(lock, wind, widg, f, os);

/*
 * How should an EXIT but not SELECTABLE be handled?
 */
		}
		else if (form[f].ob_flags & SELECTABLE)	/* Selectable object? */
		{
/*
 * Should this perhaps be done in watch_object?
 */
			form[f].ob_state = is;
			CLIP(form, f, r);
			v_hide_c(V_handle);
			draw_object_tree(form, f, MAX_DEPTH);
			v_show_c(V_handle, 1);
	
			if (watch_object(form, f, is, os))
			{
#ifdef CLIP
				set_clip(&r);
#endif
				if (form[f].ob_flags & RBUTTON)		/* Was click on a radio button? */
					Radio_b(form, f);
					
				if (form[f].ob_flags & EXIT)		/* Exit button? */
					exit_form(lock, wind, widg, f, os);
			}
		}
	}
	
#ifdef CLIP
	clear_clip();
#endif
	
	return FALSE;
}

/*
 * Form_do() double click handler
 */
 
WidgetBehaviour dclick_object_widget	/* (XA_WINDOW *wind, XA_WIDGET *widg) */
{
	short f, is, os;
	RECT r;
/*	unsigned long retv = XA_OK;
*/	XA_WIDGET_TREE *wt = widg->stuff;
	OBJECT *form;

	if (window_list != wind)
	{
		focus = pull_wind_to_top(lock, wind);			/* HR */
		after_top(lock, false);							/* HR */
		display_non_topped_window(lock, 53, wind, nil);
		return FALSE;
	}
   
	form = wt->tree;

	rp_2_ap(wind, widg, &r);	/* Convert relative coords and window location to absolute screen location */

	f = find_object(form, 0, 10, r.x + widg->click_x, r.y + widg->click_y);

	/* find_object can't report click on a HIDETREE object. */
	if (    (form[f].ob_state & DISABLED)	/* Was click on a valid selectable object? */
		|| !(form[f].ob_flags & (EDITABLE | SELECTABLE | EXIT | TOUCHEXIT))
		)
	{	
		return FALSE;
	}

	switch(form[f].ob_type&0xff)
	{
	case G_SLIST:
		dclick_scroll_list(lock, form, f, r.x + widg->click_x, r.y + widg->click_y);
		break;
	}
	
	return FALSE;
}

/*
 * HR: Direct display of the toolbar widget
 */

void display_toolbar(LOCK lock, XA_WINDOW *wind, short item)
{
	XA_WIDGET *widg = &wind->widgets[XAW_TOOLBAR];
DIAG((D.fsel,-1,"display_toolbar\n"));
	v_hide_c(V_handle);
	widg->start = item;
	(*widg->behaviour[XACB_DISPLAY])(lock, wind, widg);
	v_show_c(V_handle, 1);
	widg->start = wind->item;
DIAG((D.fsel,-1,"display_toolbar\n"));
}

/*
 * Form Keyboard Handler for toolbars
 */

/* HR: more code duplication removed. */
/* Reduction of clumsyness.
   (clumsyness mainly caused by pathological use of for statement) */
/* N.B.  A form could be a single editable boxtext!            */
short form_cur(OBJECT *form, short keycode, short obj)
{
#define editable (form[o].ob_flags & EDITABLE)

	short o = obj, ed = 0,
	      last_ob = 0;
	while ( ! (form[last_ob].ob_flags & LASTOB))	/* Find last object & check for editable */
	{
		ed |= form[last_ob].ob_flags & EDITABLE;
		last_ob++;	
	}

	switch(keycode)		/* Must handle the cursor keys, whether editable or not, cause
							we want to return obj for cursor keys otherwise -1.
							This is also a safeguard.  */
	{
	case 0x0f09:		/* TAB moves to next field */
	case 0x5000:		/* DOWN ARROW also moves to next field */
		if (ed)
			do   o = o == last_ob ? 0       : o + 1;			/* loop round */
			while (!editable);
		break;

	case 0x4800:		/* UP ARROW moves to previous field */
		if (ed)
			do   o = o == 0       ? last_ob : o - 1;			/* loop round */
			while (!editable);
		break;

	case 0x4737:		/* SHIFT+HOME */
	case 0x5032:		/* SHIFT+DOWN ARROW moves to last field */
	case 0x5100:		/* page down key (Milan &| emulators)   */
		if (ed)
		{
			o = last_ob;
			while (!editable) o--;		/* Search for last editable object */
		}
		break;

	case 0x4700:		/* HOME */
	case 0x4838:		/* SHIFT+UP ARROW moves to first field */
	case 0x4900:		/* page up key (Milan &| emulators)    */
		if (ed)
		{
			o = 0;
			while (!editable) o++;		/* Search for first editable object */
		}
		break;

	default:
		o = -1;
	}
	return o;
}
